// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package application

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
)

// ApplicationMetaData contains all meta data concerning the Application contract.
var ApplicationMetaData = &bind.MetaData{
	ABI: "[{\"inputs\":[{\"internalType\":\"address\",\"name\":\"const\",\"type\":\"address\"}],\"stateMutability\":\"nonpayable\",\"type\":\"constructor\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"previousOwner\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"OwnershipTransferred\",\"type\":\"event\"},{\"inputs\":[],\"name\":\"_const\",\"outputs\":[{\"internalType\":\"contractICloudConstant\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"_admin\",\"type\":\"address\"}],\"name\":\"addAdmin\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"nodeId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"appId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"name\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"version\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"status\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"resolutionRatio\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"fps\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"gamePads\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"isHdrSupported\",\"type\":\"string\"}],\"name\":\"addAppInfo\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"nodeId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"externalIp\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"serverPort\",\"type\":\"string\"},{\"internalType\":\"string[]\",\"name\":\"stunIp\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"turnIp\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"turnUser\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"turnPwd\",\"type\":\"string[]\"},{\"internalType\":\"string\",\"name\":\"signallingHttpIp\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"signallingWsIp\",\"type\":\"string\"}],\"name\":\"addNodeNetworkInfo\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"nodeId\",\"type\":\"string\"},{\"internalType\":\"string[]\",\"name\":\"appId\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"name\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"version\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"status\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"resolutionRatio\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"fps\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"gamePads\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"isHdrSupported\",\"type\":\"string[]\"}],\"name\":\"batchAddAppInfo\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"_admin\",\"type\":\"address\"}],\"name\":\"delAdmin\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint8\",\"name\":\"start\",\"type\":\"uint8\"},{\"internalType\":\"uint8\",\"name\":\"count\",\"type\":\"uint8\"}],\"name\":\"getAppIds\",\"outputs\":[{\"internalType\":\"string[]\",\"name\":\"res\",\"type\":\"string[]\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"nodeId\",\"type\":\"string\"},{\"internalType\":\"uint8\",\"name\":\"start\",\"type\":\"uint8\"},{\"internalType\":\"uint8\",\"name\":\"count\",\"type\":\"uint8\"}],\"name\":\"getAppIdsForNode\",\"outputs\":[{\"internalType\":\"string[]\",\"name\":\"res\",\"type\":\"string[]\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"appId\",\"type\":\"string\"}],\"name\":\"getAppInfo\",\"outputs\":[{\"internalType\":\"string\",\"name\":\"name\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"version\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"status\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"resolutionRatio\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"fps\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"gamePads\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"isHdrSupported\",\"type\":\"string\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"appId\",\"type\":\"string\"},{\"internalType\":\"uint8\",\"name\":\"start\",\"type\":\"uint8\"},{\"internalType\":\"uint8\",\"name\":\"count\",\"type\":\"uint8\"}],\"name\":\"getNodeIds\",\"outputs\":[{\"internalType\":\"string[]\",\"name\":\"res\",\"type\":\"string[]\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"nodeId\",\"type\":\"string\"}],\"name\":\"getNodeNetwork\",\"outputs\":[{\"internalType\":\"string\",\"name\":\"externalIp\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"serverPort\",\"type\":\"string\"},{\"internalType\":\"string[]\",\"name\":\"stunIp\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"turnIp\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"turnUser\",\"type\":\"string[]\"},{\"internalType\":\"string[]\",\"name\":\"turnPwd\",\"type\":\"string[]\"},{\"internalType\":\"string\",\"name\":\"signallingHttpIp\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"signallingWsIp\",\"type\":\"string\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"_addr\",\"type\":\"address\"}],\"name\":\"isAdmin\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"appId\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"nodeId\",\"type\":\"string\"}],\"name\":\"isAppBoundToNode\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"owner\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"renounceOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"const\",\"type\":\"address\"}],\"name\":\"setConstant\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"transferOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"}]",
}

// ApplicationABI is the input ABI used to generate the binding from.
// Deprecated: Use ApplicationMetaData.ABI instead.
var ApplicationABI = ApplicationMetaData.ABI

// Application is an auto generated Go binding around an Ethereum contract.
type Application struct {
	ApplicationCaller     // Read-only binding to the contract
	ApplicationTransactor // Write-only binding to the contract
	ApplicationFilterer   // Log filterer for contract events
}

// ApplicationCaller is an auto generated read-only Go binding around an Ethereum contract.
type ApplicationCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ApplicationTransactor is an auto generated write-only Go binding around an Ethereum contract.
type ApplicationTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ApplicationFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type ApplicationFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ApplicationSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type ApplicationSession struct {
	Contract     *Application      // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// ApplicationCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type ApplicationCallerSession struct {
	Contract *ApplicationCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts      // Call options to use throughout this session
}

// ApplicationTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type ApplicationTransactorSession struct {
	Contract     *ApplicationTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts      // Transaction auth options to use throughout this session
}

// ApplicationRaw is an auto generated low-level Go binding around an Ethereum contract.
type ApplicationRaw struct {
	Contract *Application // Generic contract binding to access the raw methods on
}

// ApplicationCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type ApplicationCallerRaw struct {
	Contract *ApplicationCaller // Generic read-only contract binding to access the raw methods on
}

// ApplicationTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type ApplicationTransactorRaw struct {
	Contract *ApplicationTransactor // Generic write-only contract binding to access the raw methods on
}

// NewApplication creates a new instance of Application, bound to a specific deployed contract.
func NewApplication(address common.Address, backend bind.ContractBackend) (*Application, error) {
	contract, err := bindApplication(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &Application{ApplicationCaller: ApplicationCaller{contract: contract}, ApplicationTransactor: ApplicationTransactor{contract: contract}, ApplicationFilterer: ApplicationFilterer{contract: contract}}, nil
}

// NewApplicationCaller creates a new read-only instance of Application, bound to a specific deployed contract.
func NewApplicationCaller(address common.Address, caller bind.ContractCaller) (*ApplicationCaller, error) {
	contract, err := bindApplication(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &ApplicationCaller{contract: contract}, nil
}

// NewApplicationTransactor creates a new write-only instance of Application, bound to a specific deployed contract.
func NewApplicationTransactor(address common.Address, transactor bind.ContractTransactor) (*ApplicationTransactor, error) {
	contract, err := bindApplication(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &ApplicationTransactor{contract: contract}, nil
}

// NewApplicationFilterer creates a new log filterer instance of Application, bound to a specific deployed contract.
func NewApplicationFilterer(address common.Address, filterer bind.ContractFilterer) (*ApplicationFilterer, error) {
	contract, err := bindApplication(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &ApplicationFilterer{contract: contract}, nil
}

// bindApplication binds a generic wrapper to an already deployed contract.
func bindApplication(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := abi.JSON(strings.NewReader(ApplicationABI))
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Application *ApplicationRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Application.Contract.ApplicationCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Application *ApplicationRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Application.Contract.ApplicationTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Application *ApplicationRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Application.Contract.ApplicationTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Application *ApplicationCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Application.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Application *ApplicationTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Application.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Application *ApplicationTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Application.Contract.contract.Transact(opts, method, params...)
}

// Const is a free data retrieval call binding the contract method 0xe76dba42.
//
// Solidity: function _const() view returns(address)
func (_Application *ApplicationCaller) Const(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Application.contract.Call(opts, &out, "_const")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Const is a free data retrieval call binding the contract method 0xe76dba42.
//
// Solidity: function _const() view returns(address)
func (_Application *ApplicationSession) Const() (common.Address, error) {
	return _Application.Contract.Const(&_Application.CallOpts)
}

// Const is a free data retrieval call binding the contract method 0xe76dba42.
//
// Solidity: function _const() view returns(address)
func (_Application *ApplicationCallerSession) Const() (common.Address, error) {
	return _Application.Contract.Const(&_Application.CallOpts)
}

// GetAppIds is a free data retrieval call binding the contract method 0xc317ba43.
//
// Solidity: function getAppIds(uint8 start, uint8 count) view returns(string[] res)
func (_Application *ApplicationCaller) GetAppIds(opts *bind.CallOpts, start uint8, count uint8) ([]string, error) {
	var out []interface{}
	err := _Application.contract.Call(opts, &out, "getAppIds", start, count)

	if err != nil {
		return *new([]string), err
	}

	out0 := *abi.ConvertType(out[0], new([]string)).(*[]string)

	return out0, err

}

// GetAppIds is a free data retrieval call binding the contract method 0xc317ba43.
//
// Solidity: function getAppIds(uint8 start, uint8 count) view returns(string[] res)
func (_Application *ApplicationSession) GetAppIds(start uint8, count uint8) ([]string, error) {
	return _Application.Contract.GetAppIds(&_Application.CallOpts, start, count)
}

// GetAppIds is a free data retrieval call binding the contract method 0xc317ba43.
//
// Solidity: function getAppIds(uint8 start, uint8 count) view returns(string[] res)
func (_Application *ApplicationCallerSession) GetAppIds(start uint8, count uint8) ([]string, error) {
	return _Application.Contract.GetAppIds(&_Application.CallOpts, start, count)
}

// GetAppIdsForNode is a free data retrieval call binding the contract method 0x1b10a03c.
//
// Solidity: function getAppIdsForNode(string nodeId, uint8 start, uint8 count) view returns(string[] res)
func (_Application *ApplicationCaller) GetAppIdsForNode(opts *bind.CallOpts, nodeId string, start uint8, count uint8) ([]string, error) {
	var out []interface{}
	err := _Application.contract.Call(opts, &out, "getAppIdsForNode", nodeId, start, count)

	if err != nil {
		return *new([]string), err
	}

	out0 := *abi.ConvertType(out[0], new([]string)).(*[]string)

	return out0, err

}

// GetAppIdsForNode is a free data retrieval call binding the contract method 0x1b10a03c.
//
// Solidity: function getAppIdsForNode(string nodeId, uint8 start, uint8 count) view returns(string[] res)
func (_Application *ApplicationSession) GetAppIdsForNode(nodeId string, start uint8, count uint8) ([]string, error) {
	return _Application.Contract.GetAppIdsForNode(&_Application.CallOpts, nodeId, start, count)
}

// GetAppIdsForNode is a free data retrieval call binding the contract method 0x1b10a03c.
//
// Solidity: function getAppIdsForNode(string nodeId, uint8 start, uint8 count) view returns(string[] res)
func (_Application *ApplicationCallerSession) GetAppIdsForNode(nodeId string, start uint8, count uint8) ([]string, error) {
	return _Application.Contract.GetAppIdsForNode(&_Application.CallOpts, nodeId, start, count)
}

// GetAppInfo is a free data retrieval call binding the contract method 0x3acefa17.
//
// Solidity: function getAppInfo(string appId) view returns(string name, string version, string status, string resolutionRatio, string fps, string gamePads, string isHdrSupported)
func (_Application *ApplicationCaller) GetAppInfo(opts *bind.CallOpts, appId string) (struct {
	Name            string
	Version         string
	Status          string
	ResolutionRatio string
	Fps             string
	GamePads        string
	IsHdrSupported  string
}, error) {
	var out []interface{}
	err := _Application.contract.Call(opts, &out, "getAppInfo", appId)

	outstruct := new(struct {
		Name            string
		Version         string
		Status          string
		ResolutionRatio string
		Fps             string
		GamePads        string
		IsHdrSupported  string
	})
	if err != nil {
		return *outstruct, err
	}

	outstruct.Name = *abi.ConvertType(out[0], new(string)).(*string)
	outstruct.Version = *abi.ConvertType(out[1], new(string)).(*string)
	outstruct.Status = *abi.ConvertType(out[2], new(string)).(*string)
	outstruct.ResolutionRatio = *abi.ConvertType(out[3], new(string)).(*string)
	outstruct.Fps = *abi.ConvertType(out[4], new(string)).(*string)
	outstruct.GamePads = *abi.ConvertType(out[5], new(string)).(*string)
	outstruct.IsHdrSupported = *abi.ConvertType(out[6], new(string)).(*string)

	return *outstruct, err

}

// GetAppInfo is a free data retrieval call binding the contract method 0x3acefa17.
//
// Solidity: function getAppInfo(string appId) view returns(string name, string version, string status, string resolutionRatio, string fps, string gamePads, string isHdrSupported)
func (_Application *ApplicationSession) GetAppInfo(appId string) (struct {
	Name            string
	Version         string
	Status          string
	ResolutionRatio string
	Fps             string
	GamePads        string
	IsHdrSupported  string
}, error) {
	return _Application.Contract.GetAppInfo(&_Application.CallOpts, appId)
}

// GetAppInfo is a free data retrieval call binding the contract method 0x3acefa17.
//
// Solidity: function getAppInfo(string appId) view returns(string name, string version, string status, string resolutionRatio, string fps, string gamePads, string isHdrSupported)
func (_Application *ApplicationCallerSession) GetAppInfo(appId string) (struct {
	Name            string
	Version         string
	Status          string
	ResolutionRatio string
	Fps             string
	GamePads        string
	IsHdrSupported  string
}, error) {
	return _Application.Contract.GetAppInfo(&_Application.CallOpts, appId)
}

// GetNodeIds is a free data retrieval call binding the contract method 0xb85e84c2.
//
// Solidity: function getNodeIds(string appId, uint8 start, uint8 count) view returns(string[] res)
func (_Application *ApplicationCaller) GetNodeIds(opts *bind.CallOpts, appId string, start uint8, count uint8) ([]string, error) {
	var out []interface{}
	err := _Application.contract.Call(opts, &out, "getNodeIds", appId, start, count)

	if err != nil {
		return *new([]string), err
	}

	out0 := *abi.ConvertType(out[0], new([]string)).(*[]string)

	return out0, err

}

// GetNodeIds is a free data retrieval call binding the contract method 0xb85e84c2.
//
// Solidity: function getNodeIds(string appId, uint8 start, uint8 count) view returns(string[] res)
func (_Application *ApplicationSession) GetNodeIds(appId string, start uint8, count uint8) ([]string, error) {
	return _Application.Contract.GetNodeIds(&_Application.CallOpts, appId, start, count)
}

// GetNodeIds is a free data retrieval call binding the contract method 0xb85e84c2.
//
// Solidity: function getNodeIds(string appId, uint8 start, uint8 count) view returns(string[] res)
func (_Application *ApplicationCallerSession) GetNodeIds(appId string, start uint8, count uint8) ([]string, error) {
	return _Application.Contract.GetNodeIds(&_Application.CallOpts, appId, start, count)
}

// GetNodeNetwork is a free data retrieval call binding the contract method 0xc3a616ea.
//
// Solidity: function getNodeNetwork(string nodeId) view returns(string externalIp, string serverPort, string[] stunIp, string[] turnIp, string[] turnUser, string[] turnPwd, string signallingHttpIp, string signallingWsIp)
func (_Application *ApplicationCaller) GetNodeNetwork(opts *bind.CallOpts, nodeId string) (struct {
	ExternalIp       string
	ServerPort       string
	StunIp           []string
	TurnIp           []string
	TurnUser         []string
	TurnPwd          []string
	SignallingHttpIp string
	SignallingWsIp   string
}, error) {
	var out []interface{}
	err := _Application.contract.Call(opts, &out, "getNodeNetwork", nodeId)

	outstruct := new(struct {
		ExternalIp       string
		ServerPort       string
		StunIp           []string
		TurnIp           []string
		TurnUser         []string
		TurnPwd          []string
		SignallingHttpIp string
		SignallingWsIp   string
	})
	if err != nil {
		return *outstruct, err
	}

	outstruct.ExternalIp = *abi.ConvertType(out[0], new(string)).(*string)
	outstruct.ServerPort = *abi.ConvertType(out[1], new(string)).(*string)
	outstruct.StunIp = *abi.ConvertType(out[2], new([]string)).(*[]string)
	outstruct.TurnIp = *abi.ConvertType(out[3], new([]string)).(*[]string)
	outstruct.TurnUser = *abi.ConvertType(out[4], new([]string)).(*[]string)
	outstruct.TurnPwd = *abi.ConvertType(out[5], new([]string)).(*[]string)
	outstruct.SignallingHttpIp = *abi.ConvertType(out[6], new(string)).(*string)
	outstruct.SignallingWsIp = *abi.ConvertType(out[7], new(string)).(*string)

	return *outstruct, err

}

// GetNodeNetwork is a free data retrieval call binding the contract method 0xc3a616ea.
//
// Solidity: function getNodeNetwork(string nodeId) view returns(string externalIp, string serverPort, string[] stunIp, string[] turnIp, string[] turnUser, string[] turnPwd, string signallingHttpIp, string signallingWsIp)
func (_Application *ApplicationSession) GetNodeNetwork(nodeId string) (struct {
	ExternalIp       string
	ServerPort       string
	StunIp           []string
	TurnIp           []string
	TurnUser         []string
	TurnPwd          []string
	SignallingHttpIp string
	SignallingWsIp   string
}, error) {
	return _Application.Contract.GetNodeNetwork(&_Application.CallOpts, nodeId)
}

// GetNodeNetwork is a free data retrieval call binding the contract method 0xc3a616ea.
//
// Solidity: function getNodeNetwork(string nodeId) view returns(string externalIp, string serverPort, string[] stunIp, string[] turnIp, string[] turnUser, string[] turnPwd, string signallingHttpIp, string signallingWsIp)
func (_Application *ApplicationCallerSession) GetNodeNetwork(nodeId string) (struct {
	ExternalIp       string
	ServerPort       string
	StunIp           []string
	TurnIp           []string
	TurnUser         []string
	TurnPwd          []string
	SignallingHttpIp string
	SignallingWsIp   string
}, error) {
	return _Application.Contract.GetNodeNetwork(&_Application.CallOpts, nodeId)
}

// IsAdmin is a free data retrieval call binding the contract method 0x24d7806c.
//
// Solidity: function isAdmin(address _addr) view returns(bool)
func (_Application *ApplicationCaller) IsAdmin(opts *bind.CallOpts, _addr common.Address) (bool, error) {
	var out []interface{}
	err := _Application.contract.Call(opts, &out, "isAdmin", _addr)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// IsAdmin is a free data retrieval call binding the contract method 0x24d7806c.
//
// Solidity: function isAdmin(address _addr) view returns(bool)
func (_Application *ApplicationSession) IsAdmin(_addr common.Address) (bool, error) {
	return _Application.Contract.IsAdmin(&_Application.CallOpts, _addr)
}

// IsAdmin is a free data retrieval call binding the contract method 0x24d7806c.
//
// Solidity: function isAdmin(address _addr) view returns(bool)
func (_Application *ApplicationCallerSession) IsAdmin(_addr common.Address) (bool, error) {
	return _Application.Contract.IsAdmin(&_Application.CallOpts, _addr)
}

// IsAppBoundToNode is a free data retrieval call binding the contract method 0xfbbaf2c1.
//
// Solidity: function isAppBoundToNode(string appId, string nodeId) view returns(bool)
func (_Application *ApplicationCaller) IsAppBoundToNode(opts *bind.CallOpts, appId string, nodeId string) (bool, error) {
	var out []interface{}
	err := _Application.contract.Call(opts, &out, "isAppBoundToNode", appId, nodeId)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// IsAppBoundToNode is a free data retrieval call binding the contract method 0xfbbaf2c1.
//
// Solidity: function isAppBoundToNode(string appId, string nodeId) view returns(bool)
func (_Application *ApplicationSession) IsAppBoundToNode(appId string, nodeId string) (bool, error) {
	return _Application.Contract.IsAppBoundToNode(&_Application.CallOpts, appId, nodeId)
}

// IsAppBoundToNode is a free data retrieval call binding the contract method 0xfbbaf2c1.
//
// Solidity: function isAppBoundToNode(string appId, string nodeId) view returns(bool)
func (_Application *ApplicationCallerSession) IsAppBoundToNode(appId string, nodeId string) (bool, error) {
	return _Application.Contract.IsAppBoundToNode(&_Application.CallOpts, appId, nodeId)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Application *ApplicationCaller) Owner(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Application.contract.Call(opts, &out, "owner")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Application *ApplicationSession) Owner() (common.Address, error) {
	return _Application.Contract.Owner(&_Application.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Application *ApplicationCallerSession) Owner() (common.Address, error) {
	return _Application.Contract.Owner(&_Application.CallOpts)
}

// AddAdmin is a paid mutator transaction binding the contract method 0x70480275.
//
// Solidity: function addAdmin(address _admin) returns()
func (_Application *ApplicationTransactor) AddAdmin(opts *bind.TransactOpts, _admin common.Address) (*types.Transaction, error) {
	return _Application.contract.Transact(opts, "addAdmin", _admin)
}

// AddAdmin is a paid mutator transaction binding the contract method 0x70480275.
//
// Solidity: function addAdmin(address _admin) returns()
func (_Application *ApplicationSession) AddAdmin(_admin common.Address) (*types.Transaction, error) {
	return _Application.Contract.AddAdmin(&_Application.TransactOpts, _admin)
}

// AddAdmin is a paid mutator transaction binding the contract method 0x70480275.
//
// Solidity: function addAdmin(address _admin) returns()
func (_Application *ApplicationTransactorSession) AddAdmin(_admin common.Address) (*types.Transaction, error) {
	return _Application.Contract.AddAdmin(&_Application.TransactOpts, _admin)
}

// AddAppInfo is a paid mutator transaction binding the contract method 0x5ea4ff47.
//
// Solidity: function addAppInfo(string nodeId, string appId, string name, string version, string status, string resolutionRatio, string fps, string gamePads, string isHdrSupported) returns()
func (_Application *ApplicationTransactor) AddAppInfo(opts *bind.TransactOpts, nodeId string, appId string, name string, version string, status string, resolutionRatio string, fps string, gamePads string, isHdrSupported string) (*types.Transaction, error) {
	return _Application.contract.Transact(opts, "addAppInfo", nodeId, appId, name, version, status, resolutionRatio, fps, gamePads, isHdrSupported)
}

// AddAppInfo is a paid mutator transaction binding the contract method 0x5ea4ff47.
//
// Solidity: function addAppInfo(string nodeId, string appId, string name, string version, string status, string resolutionRatio, string fps, string gamePads, string isHdrSupported) returns()
func (_Application *ApplicationSession) AddAppInfo(nodeId string, appId string, name string, version string, status string, resolutionRatio string, fps string, gamePads string, isHdrSupported string) (*types.Transaction, error) {
	return _Application.Contract.AddAppInfo(&_Application.TransactOpts, nodeId, appId, name, version, status, resolutionRatio, fps, gamePads, isHdrSupported)
}

// AddAppInfo is a paid mutator transaction binding the contract method 0x5ea4ff47.
//
// Solidity: function addAppInfo(string nodeId, string appId, string name, string version, string status, string resolutionRatio, string fps, string gamePads, string isHdrSupported) returns()
func (_Application *ApplicationTransactorSession) AddAppInfo(nodeId string, appId string, name string, version string, status string, resolutionRatio string, fps string, gamePads string, isHdrSupported string) (*types.Transaction, error) {
	return _Application.Contract.AddAppInfo(&_Application.TransactOpts, nodeId, appId, name, version, status, resolutionRatio, fps, gamePads, isHdrSupported)
}

// AddNodeNetworkInfo is a paid mutator transaction binding the contract method 0x103418a4.
//
// Solidity: function addNodeNetworkInfo(string nodeId, string externalIp, string serverPort, string[] stunIp, string[] turnIp, string[] turnUser, string[] turnPwd, string signallingHttpIp, string signallingWsIp) returns()
func (_Application *ApplicationTransactor) AddNodeNetworkInfo(opts *bind.TransactOpts, nodeId string, externalIp string, serverPort string, stunIp []string, turnIp []string, turnUser []string, turnPwd []string, signallingHttpIp string, signallingWsIp string) (*types.Transaction, error) {
	return _Application.contract.Transact(opts, "addNodeNetworkInfo", nodeId, externalIp, serverPort, stunIp, turnIp, turnUser, turnPwd, signallingHttpIp, signallingWsIp)
}

// AddNodeNetworkInfo is a paid mutator transaction binding the contract method 0x103418a4.
//
// Solidity: function addNodeNetworkInfo(string nodeId, string externalIp, string serverPort, string[] stunIp, string[] turnIp, string[] turnUser, string[] turnPwd, string signallingHttpIp, string signallingWsIp) returns()
func (_Application *ApplicationSession) AddNodeNetworkInfo(nodeId string, externalIp string, serverPort string, stunIp []string, turnIp []string, turnUser []string, turnPwd []string, signallingHttpIp string, signallingWsIp string) (*types.Transaction, error) {
	return _Application.Contract.AddNodeNetworkInfo(&_Application.TransactOpts, nodeId, externalIp, serverPort, stunIp, turnIp, turnUser, turnPwd, signallingHttpIp, signallingWsIp)
}

// AddNodeNetworkInfo is a paid mutator transaction binding the contract method 0x103418a4.
//
// Solidity: function addNodeNetworkInfo(string nodeId, string externalIp, string serverPort, string[] stunIp, string[] turnIp, string[] turnUser, string[] turnPwd, string signallingHttpIp, string signallingWsIp) returns()
func (_Application *ApplicationTransactorSession) AddNodeNetworkInfo(nodeId string, externalIp string, serverPort string, stunIp []string, turnIp []string, turnUser []string, turnPwd []string, signallingHttpIp string, signallingWsIp string) (*types.Transaction, error) {
	return _Application.Contract.AddNodeNetworkInfo(&_Application.TransactOpts, nodeId, externalIp, serverPort, stunIp, turnIp, turnUser, turnPwd, signallingHttpIp, signallingWsIp)
}

// BatchAddAppInfo is a paid mutator transaction binding the contract method 0x93c011c2.
//
// Solidity: function batchAddAppInfo(string nodeId, string[] appId, string[] name, string[] version, string[] status, string[] resolutionRatio, string[] fps, string[] gamePads, string[] isHdrSupported) returns()
func (_Application *ApplicationTransactor) BatchAddAppInfo(opts *bind.TransactOpts, nodeId string, appId []string, name []string, version []string, status []string, resolutionRatio []string, fps []string, gamePads []string, isHdrSupported []string) (*types.Transaction, error) {
	return _Application.contract.Transact(opts, "batchAddAppInfo", nodeId, appId, name, version, status, resolutionRatio, fps, gamePads, isHdrSupported)
}

// BatchAddAppInfo is a paid mutator transaction binding the contract method 0x93c011c2.
//
// Solidity: function batchAddAppInfo(string nodeId, string[] appId, string[] name, string[] version, string[] status, string[] resolutionRatio, string[] fps, string[] gamePads, string[] isHdrSupported) returns()
func (_Application *ApplicationSession) BatchAddAppInfo(nodeId string, appId []string, name []string, version []string, status []string, resolutionRatio []string, fps []string, gamePads []string, isHdrSupported []string) (*types.Transaction, error) {
	return _Application.Contract.BatchAddAppInfo(&_Application.TransactOpts, nodeId, appId, name, version, status, resolutionRatio, fps, gamePads, isHdrSupported)
}

// BatchAddAppInfo is a paid mutator transaction binding the contract method 0x93c011c2.
//
// Solidity: function batchAddAppInfo(string nodeId, string[] appId, string[] name, string[] version, string[] status, string[] resolutionRatio, string[] fps, string[] gamePads, string[] isHdrSupported) returns()
func (_Application *ApplicationTransactorSession) BatchAddAppInfo(nodeId string, appId []string, name []string, version []string, status []string, resolutionRatio []string, fps []string, gamePads []string, isHdrSupported []string) (*types.Transaction, error) {
	return _Application.Contract.BatchAddAppInfo(&_Application.TransactOpts, nodeId, appId, name, version, status, resolutionRatio, fps, gamePads, isHdrSupported)
}

// DelAdmin is a paid mutator transaction binding the contract method 0x62d91855.
//
// Solidity: function delAdmin(address _admin) returns()
func (_Application *ApplicationTransactor) DelAdmin(opts *bind.TransactOpts, _admin common.Address) (*types.Transaction, error) {
	return _Application.contract.Transact(opts, "delAdmin", _admin)
}

// DelAdmin is a paid mutator transaction binding the contract method 0x62d91855.
//
// Solidity: function delAdmin(address _admin) returns()
func (_Application *ApplicationSession) DelAdmin(_admin common.Address) (*types.Transaction, error) {
	return _Application.Contract.DelAdmin(&_Application.TransactOpts, _admin)
}

// DelAdmin is a paid mutator transaction binding the contract method 0x62d91855.
//
// Solidity: function delAdmin(address _admin) returns()
func (_Application *ApplicationTransactorSession) DelAdmin(_admin common.Address) (*types.Transaction, error) {
	return _Application.Contract.DelAdmin(&_Application.TransactOpts, _admin)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Application *ApplicationTransactor) RenounceOwnership(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Application.contract.Transact(opts, "renounceOwnership")
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Application *ApplicationSession) RenounceOwnership() (*types.Transaction, error) {
	return _Application.Contract.RenounceOwnership(&_Application.TransactOpts)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Application *ApplicationTransactorSession) RenounceOwnership() (*types.Transaction, error) {
	return _Application.Contract.RenounceOwnership(&_Application.TransactOpts)
}

// SetConstant is a paid mutator transaction binding the contract method 0xc88e7e42.
//
// Solidity: function setConstant(address const) returns()
func (_Application *ApplicationTransactor) SetConstant(opts *bind.TransactOpts, arg0 common.Address) (*types.Transaction, error) {
	return _Application.contract.Transact(opts, "setConstant", arg0)
}

// SetConstant is a paid mutator transaction binding the contract method 0xc88e7e42.
//
// Solidity: function setConstant(address const) returns()
func (_Application *ApplicationSession) SetConstant(arg0 common.Address) (*types.Transaction, error) {
	return _Application.Contract.SetConstant(&_Application.TransactOpts, arg0)
}

// SetConstant is a paid mutator transaction binding the contract method 0xc88e7e42.
//
// Solidity: function setConstant(address const) returns()
func (_Application *ApplicationTransactorSession) SetConstant(arg0 common.Address) (*types.Transaction, error) {
	return _Application.Contract.SetConstant(&_Application.TransactOpts, arg0)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Application *ApplicationTransactor) TransferOwnership(opts *bind.TransactOpts, newOwner common.Address) (*types.Transaction, error) {
	return _Application.contract.Transact(opts, "transferOwnership", newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Application *ApplicationSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _Application.Contract.TransferOwnership(&_Application.TransactOpts, newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Application *ApplicationTransactorSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _Application.Contract.TransferOwnership(&_Application.TransactOpts, newOwner)
}

// ApplicationOwnershipTransferredIterator is returned from FilterOwnershipTransferred and is used to iterate over the raw logs and unpacked data for OwnershipTransferred events raised by the Application contract.
type ApplicationOwnershipTransferredIterator struct {
	Event *ApplicationOwnershipTransferred // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ApplicationOwnershipTransferredIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ApplicationOwnershipTransferred)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ApplicationOwnershipTransferred)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ApplicationOwnershipTransferredIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ApplicationOwnershipTransferredIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ApplicationOwnershipTransferred represents a OwnershipTransferred event raised by the Application contract.
type ApplicationOwnershipTransferred struct {
	PreviousOwner common.Address
	NewOwner      common.Address
	Raw           types.Log // Blockchain specific contextual infos
}

// FilterOwnershipTransferred is a free log retrieval operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Application *ApplicationFilterer) FilterOwnershipTransferred(opts *bind.FilterOpts, previousOwner []common.Address, newOwner []common.Address) (*ApplicationOwnershipTransferredIterator, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _Application.contract.FilterLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return &ApplicationOwnershipTransferredIterator{contract: _Application.contract, event: "OwnershipTransferred", logs: logs, sub: sub}, nil
}

// WatchOwnershipTransferred is a free log subscription operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Application *ApplicationFilterer) WatchOwnershipTransferred(opts *bind.WatchOpts, sink chan<- *ApplicationOwnershipTransferred, previousOwner []common.Address, newOwner []common.Address) (event.Subscription, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _Application.contract.WatchLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ApplicationOwnershipTransferred)
				if err := _Application.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseOwnershipTransferred is a log parse operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Application *ApplicationFilterer) ParseOwnershipTransferred(log types.Log) (*ApplicationOwnershipTransferred, error) {
	event := new(ApplicationOwnershipTransferred)
	if err := _Application.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}
